<template>
	<div class="page">
		<el-form :inline="true"  v-if="searchVisible" class="query-form m-b-10" ref="searchForm" :model="searchForm" @keyup.enter.native="refreshList()" @submit.native.prevent>
			<!-- 搜索框-->
			<el-form-item label="标题" prop="title">
				<el-input v-model="searchForm.title" placeholder="请输入标题" clearable></el-input>
			</el-form-item>
			<el-form-item  label="发起人" prop="createById">
				<UserSelect :limit='1' :modelValue="searchForm.createById" @update:modelValue='(value, label) => {searchForm.createById = value}'></UserSelect>
			</el-form-item>
			<el-form-item   prop="officeId" label="发起人部门">
				<SelectTree
					ref="officeTree"
					:props="{
                  value: 'id',             // ID字段名
                  label: 'name',         // 显示名称
                  children: 'children'    // 子级字段名
                }"

					:url="`/system-server/sys/office/treeData?type=2`"
					:value="searchForm.officeId"
					size="default"
					:accordion="true"
					@getValue="(value) => {searchForm.officeId=value}"/>
			</el-form-item>
			<el-form-item v-if="showHideItem" label="会议开始时间" prop="meetingDates">
				<el-date-picker
					style="width:50%;"
					v-model="searchForm.meetingDates"
					type="daterange"
					value-format="YYYY-MM-DD"
					placeholder="请选择日期"
				/>
			</el-form-item>
			<el-form-item v-if="showHideItem" label="会议室编号" prop="meetNumber">
				<el-select v-model="searchForm.meetNumber" placeholder="请选择" style="width:100%;">
					<el-option
						v-for="item in $dictUtils.getDictList('meet_number')"
						:key="item.value"
						:label="item.label"
						:value="item.value">
					</el-option>
				</el-select>
			</el-form-item>

			<el-form-item>
				<el-button type="default" @click="showHide" :icon="showHideIcon">{{showHideName}}</el-button>
				<el-button type="primary" @click="refreshList()" icon="el-icon-search">查询</el-button>
				<el-button @click="resetSearch()" icon="el-icon-refresh-right">重置</el-button>
			</el-form-item>
		</el-form>
		<div class="jp-table top" style="">
			<vxe-toolbar ref="toolbarRef" :refresh="{query: refreshList}" export custom>
				<template #buttons>
					<el-button :disabled="isAdmin" type="primary" icon="el-icon-plus" @click="add()">新建</el-button>
				</template>
				<template #tools>
					<vxe-button
						text
						type="primary"
						:title="searchVisible ? '收起检索' : '展开检索'"
						icon="vxe-icon-search"
						class="tool-btn"
						@click="searchVisible = !searchVisible"
					></vxe-button>
				</template>
			</vxe-toolbar>
			<div style="height: calc(100% - 90px)">
				<vxe-table
					border="inner"
					auto-resize
					resizable
					height="auto"
					:loading="loading"
					ref="roomTable"
					show-header-overflow
					show-overflow
					highlight-hover-row
					:menu-config="{}"
					@sort-change="sortChangeHandle"
					:export-config="{
									remote: true,
									filename: `会议室预约数据${moment(new Date()).format('YYYY-MM-DD')}`,
									sheetName: `会议室预约数据${moment(new Date()).format('YYYY-MM-DD')}`,
									exportMethod: exportMethod,
									types: ['xls'],
									modes: ['current', 'selected', 'all']
								  }"
					:sort-config="{remote:true}"
					:data="dataList"
					:checkbox-config="{}">
					<vxe-column type="seq" width="60" title="序号"></vxe-column>
					<vxe-column min-width="160" align="center" title="会议室" field="meetNumber">
						<template #default="scope">
							<el-link type="primary" :underline="false"  @click="view(scope.row)">{{$dictUtils.getDictLabel("meet_number", scope.row.meetNumber, '未登记')}}</el-link>
						</template>
					</vxe-column>
					<vxe-column min-width="160" align="center" title="标题" field="title"></vxe-column>
					<vxe-column min-width="160" align="center" title="会议开始时间" field="startDateTime"></vxe-column>
					<vxe-column min-width="160" align="center" title="会议结束时间" field="endDateTime"></vxe-column>
					<vxe-column min-width="160" align="center" title="会议时长" field="duration">
						<template #default="scope">
							<span v-if="scope.row.duration === 30">{{scope.row.duration}}分钟</span>
							<span v-else-if="scope.row.duration != 30 && scope.row.duration != 24">{{scope.row.duration}}小时</span>
							<span v-else-if="scope.row.duration === 24">全天</span>
						</template>
					</vxe-column>
					<vxe-column min-width="160" align="center" title="会议说明" field="remarks"></vxe-column>
					<vxe-column min-width="160" align="center" title="会议发起人" field="createName"></vxe-column>
					<vxe-column min-width="160" align="center" title="发起人部门" field="officeName"></vxe-column>
					<vxe-column min-width="160" align="center" title="发起时间" field="createDate"></vxe-column>
					<vxe-column  min-width="150px" align="center" title="状态" field="status" fixed="right">
						<template #default="scope">
							<el-button @click="detail(scope.row)" :type="$dictUtils.getDictLabel('program_project_list_info_status_info', scope.row.status, '')" effect="dark" >{{$dictUtils.getDictLabel("program_project_list_info_status", scope.row.status, '未登记')}} </el-button>
						</template>
					</vxe-column>
					<vxe-column title="操作" width="150px" fixed="right" align="center">
						<template  #default="scope">
							<div v-if="isAdmin">
								<el-button text type="primary" size="small" v-if="isAdmin" @click="adminEdit(scope.row.id)">修改</el-button>
								<el-button text type="primary" size="small" v-if="isAdmin" @click="del(scope.row.id)">删除</el-button>
							</div>
							<div v-else>
								<el-button v-if=" (scope.row.status === '1'|| scope.row.status === '3') &&scope.row.createById === $store.state.user.id" size="small" text type="primary"  @click="edit(scope.row)">修改</el-button>
								<el-button text type="primary" size="small" v-if="(scope.row.status==='0' || scope.row.status==='1'|| scope.row.status==='3') &&scope.row.createById === $store.state.user.id" @click="del(scope.row.id)">删除</el-button>
								<!--              当前申请人撤回-->
								<el-button v-if="scope.row.createById === $store.state.user.id && scope.row.status==='2'" text type="primary" size="small" @click="reback(scope.row)">撤回</el-button>

								<el-button v-if="scope.row.status==='2' && checkIsAudit(scope.row)" text type="primary" size="small" @click="examine(scope.row)">审核</el-button>
								<el-button v-if="scope.row.status === '4'&&scope.row.createById === $store.state.user.id" text type="primary" size="small" @click="adjust(scope.row)">驳回调整</el-button>
							</div>
						</template>
					</vxe-column>
				</vxe-table>
				<vxe-pager
					background
					:current-page="tablePage.currentPage"
					:page-size="tablePage.pageSize"
					:total="tablePage.total"
					:page-sizes="[10, 20, 100, 1000, {label: '全量数据', value: 1000000}]"
					:layouts="['PrevPage', 'JumpNumber', 'NextPage', 'FullJump', 'Sizes', 'Total']"
					@page-change="currentChangeHandle">
				</vxe-pager>

			</div>
		</div>

			<MeetingForm ref="meetingForm" @refreshList="refreshList"></MeetingForm>
	</div>

</template>

<script>
	import UserSelect from '@/components/userSelect'
	import SelectTree from '@/components/treeSelect/treeSelect.vue'
	import MeetingRoom from '@/api/dailyOfficeWork/MeetingRoomService'
	import taskService from '@/api/flowable/taskService'
	import processService from '@/api/flowable/processService'
	import userService from '@/api/sys/userService'
	import pick from 'lodash.pick'
	import SupplierChooseForm from '@/views/materialManagement/supplier/SupplierChooseForm'
	import MeetingForm from './MeetingForm'
	export default {
		data () {
			return {
				dialogTableVisible:false,
				searchVisible: true,
				showHideItem: false,
				showHideIcon: 'el-icon-arrow-down',
				showHideName: '展示',
				num: 0,
				searchForm: {
					title: '',
					createById: '',
					officeId: '',
					meetingDates: [],
					meetNumber:'',
				},
				dataList: [],
				tablePage: {
					total: 0,
					currentPage: 1,
					pageSize: 10,
					orders: []
				},
				tableKey: '',
				loading: false,
				processDefinitionId: '',
				procDefKey: '',
				isAdmin: false,
				create: '',
				gridData:[],
				typeData:[],
			}
		},
		MeetingRoom:null,
		created () {
			this.meetingRoomServie=new MeetingRoom()
		},
		components: {
			SelectTree,
			UserSelect,
			SupplierChooseForm,
			MeetingForm
		},
		computed: {
			userName () {
				return this.$store.state.user.name
			},
			user () {
				this.createName = this.$store.state.user.name
				return this.$store.state.user
			}
		},
		mounted () {
			this.$nextTick(() => {
				// 将表格和工具栏进行关联
				const $table = this.$refs.roomTable;
				const $toolbar = this.$refs.toolbarRef;
				$table.connect($toolbar);
			});
			this.refreshList()
		},
		activated () {
			this.refreshList()
		},
		methods: {
			showHide () {
				if (this.showHideItem === false) {
					this.showHideItem = true
					this.showHideIcon = 'el-icon-arrow-up'
					this.showHideName = '隐藏'
				} else {
					this.showHideItem = false
					this.showHideIcon = 'el-icon-arrow-down'
					this.showHideName = '展示'
				}
			},
			// 新增
			add () {
				// 读取流程表单
				let tabTitle = `发起流程【会议室预约】`
				let processTitle = `${this.userName} 在 ${this.moment(new Date()).format('YYYY-MM-DD HH:mm')} 发起了 [会议室预约]`
				taskService.getTaskDef({ procDefId: this.processDefinitionId,
					status: 'startAndHold'}).then((data) => {
					this.$router.push({
						path: '/flowable/task/TaskForm',
						query: {
							...pick(data, 'formType', 'formUrl', 'procDefKey', 'taskDefKey', 'procInsId', 'procDefId', 'taskId', 'status', 'title'),
							procDefId: this.processDefinitionId,
							procDefKey: this.procDefKey,
							status: 'startAndHold',
							title: tabTitle,
							formType: data.formType,
							formUrl: data.formUrl,
							formTitle: processTitle,
							businessId: 'false',
							isShow: false,
							routePath: '/dailyOfficeWork/daily/MeetingRoomList'
						}
					})
				})
			},
			// 修改
			edit (row) {
				let tabTitle = `发起流程【会议室预约流程】`
				let processTitle = `${this.userName} 在 ${this.moment(new Date()).format('YYYY-MM-DD HH:mm')} 发起了 [会议室预约流程]`
				taskService.getTaskDef({ procDefId: this.processDefinitionId,
					businessId: row.id,
					businessTable: 'meeting_room',
					status: 'startAndHold'}).then((data) => {
					this.$router.push({
						path: '/flowable/task/TaskForm',
						query: {
							...pick(data, 'formType', 'formUrl', 'procDefKey', 'taskDefKey', 'procInsId', 'procDefId', 'taskId', 'status', 'title'),
							procDefId: this.processDefinitionId,
							procDefKey: this.procDefKey,
							status: 'startAndHold',
							title: tabTitle,
							formType: data.formType,
							formUrl: data.formUrl,
							formTitle: processTitle,
							businessId: row.id,
							businessTable: 'meeting_room',
							isShow: false,
							routePath: '/dailyOfficeWork/daily/MeetingRoomList'
						}
					})
				})
			},
			// 查看
			view (row) {
				console.log('row',row)
				this.$refs.meetingForm.init('view',row.id)
			},
			adminEdit(id){
				this.$refs.meetingForm.init('edit',id)
			},
			// 查询当前用户是否是管理员用户
			checkIsAdmin () {
				userService.is().then((data) => {
					this.isAdmin = data
				})
			},
			// 获取数据列表
			refreshList () {
				this.loading = true
				this.meetingRoomServie.list({
					'current': this.tablePage.currentPage,
					'size': this.tablePage.pageSize,
					'orders': this.tablePage.orders,
					...this.searchForm
				}).then((data) => {
					console.log('x',data.records)
					this.dataList = data.records
					this.tablePage.total = data.total
					this.tableKey = Math.random()
					this.loading = false
				})
				this.checkIsAdmin()
				processService.getByName('会议室预约').then((data) => {
					if (!this.commonJS.isEmpty(data.id)) {
						this.processDefinitionId = data.id
						this.procDefKey = data.key
					}
				})
			},
			// 当前页
			currentChangeHandle ({ currentPage, pageSize }) {
				this.tablePage.currentPage = currentPage
				this.tablePage.pageSize = pageSize
				this.refreshList()
			},
			// 排序
			sortChangeHandle (column) {
				this.tablePage.orders = []
				if (column.order != null) {
					this.tablePage.orders.push({column: this.$utils.toLine(column.property), asc: column.order === 'asc'})
				}
				this.refreshList()
			},
			// 删除
			del (id) {
				let ids = id || this.$refs.clientTable.getCheckboxRecords().map(item => {
					return item.id
				}).join(',')
				this.$confirm(`确定删除所选项吗?`, '提示', {
					confirmButtonText: '确定',
					cancelButtonText: '取消',
					type: 'warning'
				}).then(() => {
					this.loading = true
					this.meetingRoomServie.delete(ids).then((data) => {
						this.$message.success(data)
						this.refreshList()
						this.loading = false
					})
				})
			},
			resetSearch () {
				this.$refs.searchForm.resetFields()
				this.searchForm.supplierId = '' // 重置时清空供应商筛选
				this.refreshList()
			},

			// 查看修改流程结果
			detail (row) {
				if (row.status !== '0' && row.status !== '1') {
					this.meetingRoomServie.queryById(row.id).then((da)=>{
						// eslint-disable-next-line eqeqeq
						taskService.getTaskDef({
							procInsId: row.procInsId,
							procDefId: this.processDefinitionId
						}).then((data) => {
							this.$router.push({
								path: '/flowable/task/TaskFormDetail',
								query: {
									...pick(data, 'formType', 'formUrl', 'procDefKey', 'taskDefKey', 'procInsId', 'procDefId', 'taskId', 'status', 'title'),
									isShow: 'false',
									readOnly: true,
									title: '会议室预约' + '流程详情',
									formTitle: '会议室预约' + '流程详情',
									businessId: row.id,
									status: 'reback',
									method: 'view'
								}
							})
						})
					})
				}
			},
			// 撤回入库修改
			reback (row) {
				this.$confirm(`确定要撤回该申请吗?`, '提示', {
					confirmButtonText: '确定',
					cancelButtonText: '取消',
					type: 'warning'
				}).then(() => {
					this.meetingRoomServie.queryById(row.id).then((data) => {
						if (data.status !== '2') { // status的值不等于“审核中”，就弹出提示
							this.$message.error('数据已发生改变或不存在，请刷新数据')
							this.refreshList()
						} else {
							processService.revokeProcIns(row.procInsId).then((data) => {
								let form = {status: '3', id: row.id}
								this.meetingRoomServie.updateStatusById(form)
								this.$message.success(data)
								this.refreshList()
							})
						}
					})
				})
			},
			stopUpdate (id) {
				this.meetingRoomServie.queryById(id).then((data) => {
					if (data.status !== '3') { // status的值不等于“撤回”，就弹出提示
						this.$message.error('数据已发生改变或不存在，请刷新数据')
						this.refreshList()
					} else {
						this.$confirm(`确定要取消修改申请吗?`, '提示', {
							confirmButtonText: '确定',
							cancelButtonText: '取消',
							type: 'warning'
						}).then(() => {
							this.wareHouseService.backSourceData(id).then((data) => {
								if (data.result === 'success') {
									this.$message.success('取消修改申请成功')
								} else {
									this.$message.error('取消修改申请失败')
								}
								this.refreshList()
							}).catch(() => {
								this.refreshList()
							})
						})
					}
				})
			},
			// 驳回后调整
			adjust (row) {
				this.meetingRoomServie.queryById(row.id).then((data) => {
					if (data.status !== '4') { // status的值不等于“驳回”，就弹出提示
						this.$message.error('数据已发生改变或不存在，请刷新数据')
						this.refreshList()
					} else {
						this.todo(row)
					}
				})
			},
			// 审核
			examine (row) {
				this.meetingRoomServie.queryById(row.id).then((data) => {
					if (data.status !== '2') { // status的值不等于“审核中”，就弹出提示
						this.$message.error('数据已发生改变或不存在，请刷新数据')
						this.refreshList()
					} else {
						this.todo(row)
					}
				})
			},
			// 审核或重新调整跳转
			todo (row) {
				let cUser = false
				taskService.getTaskDefInfo({
					taskId: row.taskId
				}).then((data) => {
					this.$router.push({
						path: '/flowable/task/TaskForm',
						query: {
							...pick(data, 'formType', 'formUrl', 'procDefKey', 'taskDefKey', 'procInsId', 'procDefId', 'taskId', 'status', 'title', 'businessId'),
							isShow: false,
							formReadOnly: true,
							formTitle: `${data.taskName}`,
							cUser: cUser,
							title: `审批【${data.taskName || ''}】`,
							routePath: '/dailyOfficeWork/daily/MeetingRoomList',   // 数据处理后需要跳转的页面路径
						}
					})
				})
			},
			// 查询当前登录人是否是数据的审核人
			checkIsAudit (row) {
				let loginUserId = this.$store.state.user.id  // 获取当前登录用户id
				if (this.commonJS.isNotEmpty(row.auditUserIds)) {
					for (const userId of row.auditUserIds) {
						if (userId === loginUserId) {  // 当数据的审核人中包含当前登录人id时，返回true
							return true
						}
					}
				}
				return false
			},
			//禁用日期
			disableDate(time) {
				//Date.now()是javascript中的内置函数，它返回自1970年1月1日00:00:00 UTC以来经过的毫秒数。
				return time.getTime() < Date.now() - 8.64e7;
			},
			//禁用小时
			disabledHour(){
				const arrs = []
				arrs.push(0,1,2,3,4,5,6,7,8,12,13,18,19,20,21,22,23)
				return arrs;
			},
			//禁用分钟
			disabledMinute(time){
				const arrs = []
				if (time ===17){
					for (let i = 0; i <59 ; i++) {
						arrs.push(i+1)
					}
				}
				if (time === 11){
					for (let i=0;i<59;i++){
						arrs.push(i+31)
					}
				}
				return arrs;
			},


			// 自定义服务端导出
			exportMethod ({ options }) {
				// 传给服务端的参数
				const params = {
					'current': this.tablePage.currentPage,
					'size': this.tablePage.pageSize,
					'orders': this.tablePage.orders,
					...this.searchForm,
					filename: options.filename,
					sheetName: options.sheetName,
					isHeader: options.isHeader,
					original: options.original,
					mode: options.mode,
					selectIds: options.mode === 'selected' ? options.map(item => item.id) : [],
					exportFields: options.columns.map(column => column.property)
				}
				return this.meetingRoomServie.exportFile(params).then((res) => {
					// 将二进制流文件写入excel表，以下为重要步骤
					this.$utils.downloadExcel(res, options.filename+ ".xls")
				}).catch(function (err) {
					if (err.response) {
						console.log(err.response)
					}
				})
			},



		}
	}
</script>
